/******************************(spi_EEPROM.c)***************
 *	SPIڑEEPROM(25LC1024)ǂݏCu
 ***********************************************************/

#include <stdlib.h>
#include <stdio.h>
#include "mcc_generated_files/mcc.h"
#include "spi_EEPROM.h"

#define MBFSIZE	78                      // pobt@[TCY

//=== O[oϐ ============
char     Dlm[] = ",";                   // ؂f~^
char     SBuf[20];                      // 񏈗pobt@[

//--- SPI[pϐ
static uint32_t CrtAdr = 0;             // JgAhX
static uint8_t  DBuf[MBFSIZE];          // y[Wpobt@[
static uint8_t  SqMode = 0;             // V[PX[htO
static char     lstCmd;                 // ŏIR}h

/*************************************
 *  SPIC EEPROM function
 **************************************/

//---- Xe[^X̓ǂݏo
uint8_t SPI_Rom_RdStat(){
	uint8_t stat;
	CS0_SetLow();
	SPI1_ExchangeByte(SPIROM_RD_STATS);
	stat = SPI1_ExchangeByte(0xAA);	// 0xAA̓_~[
	CS0_SetHigh();
	return stat;
}

//---- R}h24rbgAhX𑗐M 
void sendAdr(uint8_t cmd, uint32_t adr){
    CS0_SetLow();
	SPI1_ExchangeByte(cmd);			// send Command
	SPI1_ExchangeByte((uint8_t)(adr>>16));
	SPI1_ExchangeByte((uint8_t)(adr>>8));
	SPI1_ExchangeByte((uint8_t)adr);
} 
 
//-----  AhXadrA1oCgǂݏo
uint8_t SPI_Rom_Read(uint32_t adr){
	uint8_t dat;
//	CS0_SetLow();
	sendAdr(SPIROM_READcmd,adr);	// send Read_CMD & Address
	dat = SPI1_ExchangeByte(0xAA);
	CS0_SetHigh();
	return dat;
}

//-----  AhXadrɁA1oCgdt
uint8_t SPI_Rom_Write(uint32_t adr, uint8_t dat){
	CS0_SetLow();
	SPI1_ExchangeByte(SPIROM_WR_ENABL);	// Set Write Enable Bit
	CS0_SetHigh();
//	CS0_SetLow();
	sendAdr(SPIROM_WRITEcmd,adr);	// send Write_CMD & Address
	SPI1_ExchangeByte(dat);
	CS0_SetHigh();
	__delay_ms(6);
    return dat;
}

//-----  AhXadr炎oCgary[]ɓǂݏo
void SPI_Rom_NRead(uint32_t adr,uint8_t *ary,uint16_t cnt){
//	CS0_SetLow();
	sendAdr(SPIROM_READcmd,adr);	// send Read_CMD & Address
//	SPI1_ExchangeBlock(ary,cnt);
	SPI1_ReadBlock(ary,cnt);        // block read
	CS0_SetHigh();
    while(SPI_Rom_RdStat() & 1);    
}

//-----  AhXadrary[]noCg
void SPI_Rom_NWrite(uint32_t adr,uint8_t *ary,uint16_t cnt){
	CS0_SetLow();
	SPI1_ExchangeByte(SPIROM_WR_ENABL);	// Set Write Enable Bit
	CS0_SetHigh();
//	CS0_SetLow();
	sendAdr(SPIROM_WRITEcmd,adr);	// send Write_CMD & Address
//	SPI1_ExchangeBlock(ary,cnt);	// block write
	SPI1_WriteBlock(ary,cnt);	//  block write
	CS0_SetHigh();
    while(SPI_Rom_RdStat() & 1);
}

//----- `bvŜ̏
void SPI_Rom_ChipErase(){
	CS0_SetLow();
	SPI1_ExchangeByte(SPIROM_WR_ENABL);
	CS0_SetHigh();
	__delay_us(20);
	CS0_SetLow();
	SPI1_ExchangeByte(SPIROM_CP_ERASE);
	CS0_SetHigh();
	__delay_ms(15);
}

/****** ėpTu[`@********************/
//---- y[Wobt@[vg
void prt_PBf(){
    uint8_t i;
    for(i = 0; i < 64; i++){            // 164\
        #ifdef VBA
            if(i % 16 == 0) printf("\r");
        #else
            if(i % 16 == 0) printf("\n\r");
        #endif
        printf(" %02X",DBuf[i]);
    }
    puts("\r");
}

//---- 16i10iɕϊ
uint32_t my_xtoi(char *str){
    uint32_t dec;
    dec = strtoul(str,NULL,16);
//    if(errno == ERANGE) return -1;      // ϊG[
    return (uint32_t)dec;
}

/************************************
 * 	R}hANV
 ************************************/
//----- vR}h   W[aaaa][,[d0,[,]]]
uint16_t spiRom_cmd_W(char *str){
    char     *pt;                       // 񑀍p|C^
    uint8_t  last;                      // ̍Ō̈ʒu
    uint32_t res = 0;                   // Hexlϊ
    uint8_t  dt = 0;                    // ރoCgf[^
    uint16_t cnt = 0;                   // ۂɏ񂾃oCg

    lstCmd = str[0];
    if(strlen(str)==1){                 // 'W'݂̂Ȃ
        SqMode = 1;                     // A[hɃZbg
        #ifndef VBA
        	puts("SqMode ON\n\r");
        #endif
        return 0;                       // f[^͏܂Ȃ
    }
    last = (uint8_t)strlen(str)-1;      // ̍sʒu擾
    if(str[last] == ','){               // sR}Ȃ
        SqMode = 1;                     // A[hɃZbg
        #ifndef VBA
        	puts("SqMode ON\n\r");
        #endif
        str[last]='\0';                 // s̃R}
    }
    if(str[1]!=','){                    // 2R}H
        pt = strtok(str+1,Dlm);         // R}h̎
        if(pt != NULL){                 // AhXf[^
            res = my_xtoi(pt);
            CrtAdr = res;
        }
        pt = strtok(NULL,Dlm);          // 捞
    }else{
        pt = strtok(str+1,Dlm);         // 捞
    } 
    do{
        if(pt != NULL){                 // f[^邩H
            res = my_xtoi(pt);
            dt = (uint8_t)res;
 
            if(lstCmd=='W'){
                SPI_Rom_Write(CrtAdr,dt);   // f[^
            }else if(lstCmd == 'S'){
                DBuf[CrtAdr & 0x3F]= dt;  
            }
            sprintf(SBuf,"%05lX < %02X",CrtAdr,dt);
            #ifdef VBA
                printf("%s\r",SBuf);
            #else
                printf("%s\n\r",SBuf);
            #endif            
            gLCD_clrX(0,16,0,128);
            gLCD_strX(0,16,SBuf);
            CrtAdr++; cnt++;          
            pt = strtok(NULL,Dlm);      // 
        }
    }while(pt != NULL);                 // f[^邾JԂ
    return cnt;                         // 񂾕Ԃ
}

//---- qR}h  R[aaaa][,n]
uint16_t spiRom_cmd_R(char *str){
    char *pt;                           // 񑀍p|C^
    uint16_t n = 1;                     // w肳ꂽǍoCg
    uint32_t res = 0;                   // Hexlϊ
    uint8_t  dt;                        // ǂݍ񂾃oCgf[^
    uint16_t cnt = 0;                   // ۂɓǂݏoꂽoCg
    uint16_t i;                         // [vϐ
//    uint8_t dd[2];
    
    lstCmd = str[0];
    if(strlen(str) > 1){
        if(str[1]==','){
            pt = strtok(str+2,Dlm);
            if(pt != NULL){             // f[^H
                res = my_xtoi(pt);
                n = (uint16_t)res;
            }
        }else{
            pt = strtok(str+1,Dlm);
            if(pt != NULL){             // address?
                res = my_xtoi(pt);
                CrtAdr = res;
            }
            pt = strtok(NULL,Dlm);      // 
            if(pt != NULL){             // f[^H
                res = my_xtoi(pt);
                n = (uint16_t)res;
            }
        }
    }
    for(i = 0; i < n; i++ ){
        dt = SPI_Rom_Read(CrtAdr);      // f[^ǂݏo
        sprintf(SBuf,"%05lX > %02X",CrtAdr,dt);
        #ifdef VBA
        	printf("%s\r",SBuf);
        #else
        	printf("%s\n\r",SBuf);
        #endif
        gLCD_clrX(0,16,0,128);
        gLCD_strX(0,16,SBuf);
        CrtAdr++; cnt++;
    }
    SqMode = 0;
    return cnt;                         // ǂݍ񂾃f[^Ԃ
}

//---- WSQ iA[hj
uint16_t spiRom_cmd_WSQ(char *str){
    char     *pt;                       // 񑀍p|C^
    uint8_t  dt;                        // ރoCgf[^
    uint32_t res;                       // Hexlϊ
    uint16_t cnt = 0;                   // ۂɓǂݏoꂽoCg

    pt = strtok(str,Dlm);
    while(pt != NULL){                  // f[^邾JԂ
        res = my_xtoi(pt);
        dt = (uint8_t)res;
        if(lstCmd == 'W'){
            SPI_Rom_Write(CrtAdr,dt);       // f[^
        }else if(lstCmd=='S'){
			DBuf[CrtAdr & 0x3F]= dt;  
        }
        sprintf(SBuf,"%05lX < %02X",CrtAdr,dt);
        #ifdef VBA
        	printf("%s\r",SBuf);
        #else
        	printf("%s\n\r",SBuf);
        #endif
        gLCD_clrX(0,16,0,128);
        gLCD_strX(0,16,SBuf);
        CrtAdr++; cnt++;
        pt = strtok(NULL,Dlm);          // 
    }
    return cnt;                         // 񂾃f[^Ԃ
}

//---- pR}hiA[h̉j   Q
void spiRom_cmd_Q(char *str){
    lstCmd = str[0];
	SqMode = 0;
	#ifndef VBA
		puts("SqMode OFF\r");
	#endif
}

//---- t(dump)R}h    U[aaaa]
//         i64oCg̃f[^DBuf[]ɓǂݏo)
int spiRom_cmd_U(char *str){
    char    *pt;                        // 񑀍p|C^
    uint32_t res;                       // Hexlϊ
    uint32_t ad;                        // wAhX

    lstCmd = str[0];
    pt = strtok(str+1,Dlm);
    if(pt != NULL){                     // AhXLH
        res = my_xtoi(pt);
        CrtAdr = res;
    }
    ad = CrtAdr & 0xFFFFC0;               // 64oCgPʂ 
    SPI_Rom_NRead(ad, DBuf, 64);          // 64oCgDBuf[]ɓǏo
    sprintf(SBuf,"%05lX - %05lX", ad, ad+63);
//    #ifdef VBA
      	printf("%s\r",SBuf);
/*    #else
       	printf("%s\n\r",SBuf);
    #endif*/
    gLCD_clrX(0,16,0,128);
    gLCD_strX(0,16,SBuf);
    prt_PBf();
//    while(SPI_Rom_RdStat() & 1);
//    printf("ST:%02X\n\r",SPI_Rom_RdStat());
    SqMode = 0;
    return 0;
}

//---- o(Page)R}h    PW[aaaa]
//          iDBuf[]64oCgɏށj
int spiRom_cmd_P(char *str){
    char     *pt;                       // 񑀍p|C^
    uint32_t res;                       // Hexlϊ
    uint32_t ad;                        // wAhX

    lstCmd = str[0];
    if(strlen(str)==1){
        printf("PageBuffer");
        prt_PBf();
        return 0;
    }
    if(str[1]=='R'){
        spiRom_cmd_U(str+1);
        return 0;
    }
    if(str[1] != 'W') return -1;        // 2vH
    pt = strtok(str+2,Dlm);
    if(pt != NULL){                     // AhXLH
        res = my_xtoi(pt);
        CrtAdr = res;
    }
    ad = CrtAdr & 0xFFFFC0;               // 64oCgPʂ
    SPI_Rom_NWrite(ad,DBuf,64);         // DBuf[]64oCg
    sprintf(SBuf,"Page Write %05lX - %05lX",ad,ad+63);
    #ifdef VBA
      	printf("%s\r",SBuf);
    #else
       	printf("%s\n\r",SBuf);
    #endif    
    gLCD_clrX(0,16,0,128);
    gLCD_strX(0,16,SBuf);
    SqMode = 0;    
    return 0;
}

//----  V[PX[h̊mF
uint8_t spiRom_SqMode(){
	return SqMode;
}
/******* End of File ********/
